/**
* @par Copyright (C): 2010-2019, Shenzhen Yahboom Tech
* @file         advance.c
* @author       Danny
* @version      V1.0
* @date         2017.08.16
* @brief        Сǰʵ
* @details
* @par History  ˵
*
*/
#include "STC12C5A60S2.H"

//
sbit Left_motor_go=P2^1;	    //ǰAIN2
sbit Left_motor_back=P2^2;	    //AIN1
sbit Right_motor_go=P2^4;	    //ҵǰBIN2
sbit Right_motor_back=P2^3;	    // ҵBIN1
sbit Left_motor_pwm=P2^0;	    //PWMA
sbit Right_motor_pwm=P2^5;	    //ҵPWMB


//Ĭϸߵƽᵼµ̽յƣԳнõ͵ƽ
sbit LED_R = P4^6;	//LED_RSTC12C5A60S2EAP4^6ܽ
sbit LED_G = P4^5;  //LED_GSTC12C5A60S2ALEP4^5ܽ
sbit LED_B = P4^4;	//LED_BSTC12C5A60S2PSENP4^4ܽ

unsigned char pwm_val_left  =0; //
unsigned char pwm_val_right =0;

//ٶȵڱ 0-20,0С,20
unsigned char push_val_left =5; //ռձpush_val_left/20 
unsigned char push_val_right=5; //ҵռձpush_val_right/20 

bit Right_PWM_ON=1;	            //ҵPWM
bit Left_PWM_ON =1;			    //PWM

/**
* Function       delay
* @author        Danny
* @date          2017.08.16
* @brief         ʱ
* @param         xmsʱʱ䣨ms
* @retval        void
* @par History   
*/	
void delay(unsigned int xms)				
{
	unsigned int i,j;
	for(i=xms;i>0;i--)		      
    for(j=900;j>0;j--);
}

/**
* Function       pwm_out_left_motor
* @author        Danny
* @date          2017.08.16
* @brief         	,push_val_leftֵıת,ռձ
* @param         void
* @retval        void
* @par History   
*/                                        
void pwm_out_left_motor(void)
{  
	if(Left_PWM_ON)
    {
		if(pwm_val_left<=push_val_left)
		{
			Left_motor_pwm =1; 
	    }
		else 
	    {
			Left_motor_pwm=0;
        }
		if(pwm_val_left>=20)   //20pwmΪ20ms50hz
		pwm_val_left=0;
	}
	else    
    {
		Left_motor_pwm=0;      //δPWMPWMA=0 ֹͣ
	}
}

/**
* Function       pwm_out_right_motor
* @author        Danny
* @date          2017.08.16
* @brief         ҵ	,pwm_val_rightֵıת,ռձ
* @param         void
* @retval        void
* @par History   
*/  
void pwm_out_right_motor(void)
{ 
    if(Right_PWM_ON)
    { 
        if(pwm_val_right<=push_val_right)	
	    {
	        Right_motor_pwm=1; 							
        }
	    else 
	    {
	        Right_motor_pwm=0;
        }
	    if(pwm_val_right>=20) //20pwmΪ20ms50hz
	    pwm_val_right=0;
    }
    else    
    {
        Right_motor_pwm=0;	  //δPWMPWMB=0ҵֹͣ
    }
}

/**
* Function       run
* @author        Danny
* @date          2017.08.16
* @brief         Сǰ
* @param[in]      void
* @param[out]    void
* @retval        void
* @par History   
*/
void run(void)
{
	//ǰ
	Left_motor_go = 1;     //ǰʹ
	Left_motor_back = 0;   //˽ֹ
	//ָܽŵPWMֵĿʵֿ٣0-20
	push_val_left=10;
	 
	//ҵǰ
	Right_motor_go=1;    //ҵǰʹ
	Right_motor_back=0;  //ҵ˽ֹ
	//ָܽŵPWMֵĿʵֿ٣0-20
    push_val_right=10;
    return;
}

/**
* Function       timer0
* @author        Danny
* @date          2017.08.16
* @brief         TIMER0жϷӺPWMźţ
* @param[in]     void
* @param[out]    void
* @retval        void
* @par History   
*/
void timer0()interrupt 1 using 2
{
     TH0=0XFC;	      //1Msʱ
	 TL0=0X66;
	 pwm_val_left++;
	 pwm_val_right++;
	 pwm_out_left_motor();
	 pwm_out_right_motor();
}

/**
* Function       main
* @author        Danny
* @date          2017.08.16
* @brief         ʱ2sǰ
* @param[in]     void
* @retval        void
* @par History   
*/
void main()
{

//Ĭϸߵƽᵼµ̽յƣԳнõ͵ƽ

    //P4ΪͨIOʹ
	P4SW |= (1<<4);
	P4SW |= (1<<5);
	P4SW |= (1<<6);
	
	//P4Ϊǿģʽ
	P4M1 &= ~(1<<4); 
	P4M1 &= ~(1<<5);
	P4M1 &= ~(1<<6);

   	P4M0 |= (1<<4);
   	P4M0 |= (1<<5);
   	P4M0 |= (1<<6);

	LED_R=0;
	LED_G=0;   
	LED_B=0;



    P2=0XC0;    //ص	
	TMOD=0X01;  //ʱʽ1
    TH0=0XFC;   //1msʱװֵ
    TL0=0X66;
    TR0=1;		//T0
    ET0=1;		//T0ж
	EA =1;	    //ж
  
    delay(2000);//ʱ2s
  
    while(1)
    {
		run();    //ǰ
	}
	return;
}

